From d070ab28ec970465dad8ed6e52b0123b916d66e5 Mon Sep 17 00:00:00 2001
From: Stephanie Buser <sbuser@codeaurora.org>
Date: Tue, 15 Aug 2017 15:16:40 -0700
Subject: [PATCH 17/22] Syncronizing USB Function cleanup with USB IPC XPRT
 cleanup

Adding a completion event to syncronize IPC XPRT cleanup
with USB de-init.
This was causing a crash due to race condition.

Jira - NOMAD-17702
---
 drivers/usb/misc/ipcrtr.c | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

diff --git a/drivers/usb/misc/ipcrtr.c b/drivers/usb/misc/ipcrtr.c
index aa8f29e..1de38b9 100644
--- a/drivers/usb/misc/ipcrtr.c
+++ b/drivers/usb/misc/ipcrtr.c
@@ -72,6 +72,7 @@ static struct dentry *dir;
  * @opened:		Flag to indicate status of USB IPC XPRT
  * @connected:		USB cable is connected
  * @write_done:		Completion event use to ensure packet is send
+ * @xprt_cleanup_done:	Completion event use to ensure IPC XPRT cleanup is done
  * @write_result:	Result of packet submitted
  * @read_wait_q:	Wait queue used for waiting on RX packets
  * @ipcrtr_wq:		Local workqueue for exit work
@@ -103,6 +104,7 @@ struct ipcrtr {
 	bool opened;
 	atomic_t connected;
 	struct completion write_done;
+	struct completion xprt_cleanup_done;
 	int write_result;
 	wait_queue_head_t read_wait_q;
 	struct workqueue_struct *ipcrtr_wq;
@@ -549,6 +551,7 @@ static void ipcrtr_ctrl_close(void)
 	}
 	ipcrtr_ctx->opened = false;
 	mutex_unlock(&ipcrtr_ctx->open_mutex);
+	complete(&ipcrtr_ctx->xprt_cleanup_done);
 }
 
 /**
@@ -674,6 +677,7 @@ static void usb_xprt_deinit(struct work_struct *work)
 
 	/* Unregister from USB IPC XPRT Layer */
 	ret = msm_ipc_router_usb_ipc_xprt_unregister(&xprt_ops);
+	wait_for_completion(&ipcrtr_ctx->xprt_cleanup_done);
 	if (ret)
 		dev_err(&ipcrtr_ctx->intf->dev,"XPRT de-registration Failed,err#%d\n",ret);
 	else
@@ -685,7 +689,7 @@ static void usb_xprt_deinit(struct work_struct *work)
 	usb_kill_urb(ipcrtr_ctx->inturb);
 	usb_kill_urb(ipcrtr_ctx->readurb);
 
-	WARN_ON(!ipcrtr_ctx->opened);
+	WARN_ON(ipcrtr_ctx->opened);
 
 	spin_lock_irqsave(&ipcrtr_ctx->lock, flags);
 	while (!list_empty(&ipcrtr_ctx->rx_list)) {
@@ -832,6 +836,7 @@ ipcrtr_probe(struct usb_interface *intf, const struct usb_device_id *id)
 	ipcrtr->intf = intf;
 	spin_lock_init(&ipcrtr->lock);
 	init_completion(&ipcrtr->write_done);
+	init_completion(&ipcrtr->xprt_cleanup_done);
 	init_waitqueue_head(&ipcrtr->read_wait_q);
 	INIT_LIST_HEAD(&ipcrtr->rx_list);
 	mutex_init(&ipcrtr->open_mutex);
-- 
1.8.2.1

